package com.tzld.piaoquan.recommend.server.dataloader;

import com.aliyun.odps.Instance;
import com.aliyun.odps.Odps;
import com.aliyun.odps.OdpsException;
import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import com.aliyun.odps.data.Record;
import com.aliyun.odps.task.SQLTask;
import com.aliyun.odps.tunnel.io.TunnelRecordReader;
import com.google.common.collect.ListMultimap;
import com.tzld.piaoquan.recommend.server.common.ThreadPoolFactory;
import com.tzld.piaoquan.recommend.server.common.base.*;
import com.tzld.piaoquan.recommend.server.dataloader.OfflineSamplesLoader;
import com.tzld.piaoquan.recommend.server.util.JSONUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;


public class FeatureToRedisLoader {

    @Autowired
    private RedisTemplate<String, String> redisTemplate;
    private final String userKeyFormat = "user:%s";
    private ExecutorService pool = ThreadPoolFactory.defaultPool();



    public void loadFeatureToRedis(String userTable, String dt) {
        TunnelRecordReader reader = FeatureConstructor.loadDataFromOSSSession(userTable, dt);
        Record record;
        Map<String, String> userFeaRedisFormat = new HashMap<String, String>();
        int count = 0;
        try {
            while ((record = reader.read()) != null) {
                UserFeature userFeature = FeatureConstructor.constructUserFeature(record);
                String key = String.format(userKeyFormat, userFeature.getKey());
                String value = userFeature.getValue();
                userFeaRedisFormat.put(key, value);
                if(count < 10000) {
                    count++;
                } else if (count == 10000) {
                    redisTemplate.opsForValue().multiSet(userFeaRedisFormat);
                    userFeaRedisFormat = new HashMap<String, String>();
                    count = 0;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public static void main(String[] args) {

    }

}
